
package org.dmg.pmml;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlList;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for INT-SparseArray element declaration.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;element name="INT-SparseArray">
 *   &lt;complexType>
 *     &lt;complexContent>
 *       &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *         &lt;sequence>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}Indices" minOccurs="0"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}INT-Entries" minOccurs="0"/>
 *         &lt;/sequence>
 *         &lt;attribute name="n" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *         &lt;attribute name="defaultValue" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" default="0" />
 *       &lt;/restriction>
 *     &lt;/complexContent>
 *   &lt;/complexType>
 * &lt;/element>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "indices",
    "intEntries"
})
@XmlRootElement(name = "INT-SparseArray")
public class IntSparseArray
    extends SparseArray
    implements Equals, HashCode, ToString
{

    @XmlList
    @XmlElement(name = "Indices", type = Integer.class)
    protected List<Integer> indices;
    @XmlList
    @XmlElement(name = "INT-Entries", type = Integer.class)
    protected List<Integer> intEntries;
    @XmlAttribute(name = "n")
    protected BigInteger n;
    @XmlAttribute(name = "defaultValue")
    protected BigInteger defaultValue;

    /**
     * Gets the value of the indices property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the indices property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getIndices().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Integer }
     * 
     * 
     */
    public List<Integer> getIndices() {
        if (indices == null) {
            indices = new ArrayList<Integer>();
        }
        return this.indices;
    }

    /**
     * Gets the value of the intEntries property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the intEntries property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getINTEntries().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Integer }
     * 
     * 
     */
    public List<Integer> getINTEntries() {
        if (intEntries == null) {
            intEntries = new ArrayList<Integer>();
        }
        return this.intEntries;
    }

    /**
     * Gets the value of the n property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getN() {
        return n;
    }

    /**
     * Sets the value of the n property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setN(BigInteger value) {
        this.n = value;
    }

    /**
     * Gets the value of the defaultValue property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getDefaultValue() {
        if (defaultValue == null) {
            return new BigInteger("0");
        } else {
            return defaultValue;
        }
    }

    /**
     * Sets the value of the defaultValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setDefaultValue(BigInteger value) {
        this.defaultValue = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof IntSparseArray)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final IntSparseArray that = ((IntSparseArray) object);
        {
            List<Integer> lhsIndices;
            lhsIndices = (((this.indices!= null)&&(!this.indices.isEmpty()))?this.getIndices():null);
            List<Integer> rhsIndices;
            rhsIndices = (((that.indices!= null)&&(!that.indices.isEmpty()))?that.getIndices():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "indices", lhsIndices), LocatorUtils.property(thatLocator, "indices", rhsIndices), lhsIndices, rhsIndices)) {
                return false;
            }
        }
        {
            List<Integer> lhsINTEntries;
            lhsINTEntries = (((this.intEntries!= null)&&(!this.intEntries.isEmpty()))?this.getINTEntries():null);
            List<Integer> rhsINTEntries;
            rhsINTEntries = (((that.intEntries!= null)&&(!that.intEntries.isEmpty()))?that.getINTEntries():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "intEntries", lhsINTEntries), LocatorUtils.property(thatLocator, "intEntries", rhsINTEntries), lhsINTEntries, rhsINTEntries)) {
                return false;
            }
        }
        {
            BigInteger lhsN;
            lhsN = this.getN();
            BigInteger rhsN;
            rhsN = that.getN();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "n", lhsN), LocatorUtils.property(thatLocator, "n", rhsN), lhsN, rhsN)) {
                return false;
            }
        }
        {
            BigInteger lhsDefaultValue;
            lhsDefaultValue = this.getDefaultValue();
            BigInteger rhsDefaultValue;
            rhsDefaultValue = that.getDefaultValue();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "defaultValue", lhsDefaultValue), LocatorUtils.property(thatLocator, "defaultValue", rhsDefaultValue), lhsDefaultValue, rhsDefaultValue)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Integer> theIndices;
            theIndices = (((this.indices!= null)&&(!this.indices.isEmpty()))?this.getIndices():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "indices", theIndices), currentHashCode, theIndices);
        }
        {
            List<Integer> theINTEntries;
            theINTEntries = (((this.intEntries!= null)&&(!this.intEntries.isEmpty()))?this.getINTEntries():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "intEntries", theINTEntries), currentHashCode, theINTEntries);
        }
        {
            BigInteger theN;
            theN = this.getN();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "n", theN), currentHashCode, theN);
        }
        {
            BigInteger theDefaultValue;
            theDefaultValue = this.getDefaultValue();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "defaultValue", theDefaultValue), currentHashCode, theDefaultValue);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Integer> theIndices;
            theIndices = (((this.indices!= null)&&(!this.indices.isEmpty()))?this.getIndices():null);
            strategy.appendField(locator, this, "indices", buffer, theIndices);
        }
        {
            List<Integer> theINTEntries;
            theINTEntries = (((this.intEntries!= null)&&(!this.intEntries.isEmpty()))?this.getINTEntries():null);
            strategy.appendField(locator, this, "intEntries", buffer, theINTEntries);
        }
        {
            BigInteger theN;
            theN = this.getN();
            strategy.appendField(locator, this, "n", buffer, theN);
        }
        {
            BigInteger theDefaultValue;
            theDefaultValue = this.getDefaultValue();
            strategy.appendField(locator, this, "defaultValue", buffer, theDefaultValue);
        }
        return buffer;
    }

}
