
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElements;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;group ref="{http://www.dmg.org/PMML-4_1}PREDICATE"/>
 *         &lt;choice>
 *           &lt;sequence>
 *             &lt;element ref="{http://www.dmg.org/PMML-4_1}Partition" minOccurs="0"/>
 *             &lt;element ref="{http://www.dmg.org/PMML-4_1}ScoreDistribution" maxOccurs="unbounded" minOccurs="0"/>
 *             &lt;element ref="{http://www.dmg.org/PMML-4_1}Node" maxOccurs="unbounded" minOccurs="0"/>
 *           &lt;/sequence>
 *           &lt;group ref="{http://www.dmg.org/PMML-4_1}EmbeddedModel"/>
 *         &lt;/choice>
 *       &lt;/sequence>
 *       &lt;attribute name="id" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="score" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="recordCount" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="defaultChild" type="{http://www.w3.org/2001/XMLSchema}string" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "predicate",
    "partition",
    "scoreDistributions",
    "nodes",
    "embeddedModel"
})
@XmlRootElement(name = "Node")
public class Node
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElements({
        @XmlElement(name = "SimplePredicate", type = SimplePredicate.class),
        @XmlElement(name = "CompoundPredicate", type = CompoundPredicate.class),
        @XmlElement(name = "SimpleSetPredicate", type = SimpleSetPredicate.class),
        @XmlElement(name = "True", type = True.class),
        @XmlElement(name = "False", type = False.class)
    })
    protected Predicate predicate;
    @XmlElement(name = "Partition")
    protected Partition partition;
    @XmlElement(name = "ScoreDistribution")
    protected List<ScoreDistribution> scoreDistributions;
    @XmlElement(name = "Node")
    protected List<Node> nodes;
    @XmlElements({
        @XmlElement(name = "Regression", type = Regression.class),
        @XmlElement(name = "DecisionTree", type = DecisionTree.class)
    })
    protected PMMLObject embeddedModel;
    @XmlAttribute(name = "id")
    protected String id;
    @XmlAttribute(name = "score")
    protected String score;
    @XmlAttribute(name = "recordCount")
    protected Double recordCount;
    @XmlAttribute(name = "defaultChild")
    protected String defaultChild;

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the predicate property.
     * 
     * @return
     *     possible object is
     *     {@link SimplePredicate }
     *     {@link CompoundPredicate }
     *     {@link SimpleSetPredicate }
     *     {@link True }
     *     {@link False }
     *     
     */
    public Predicate getPredicate() {
        return predicate;
    }

    /**
     * Sets the value of the predicate property.
     * 
     * @param value
     *     allowed object is
     *     {@link SimplePredicate }
     *     {@link CompoundPredicate }
     *     {@link SimpleSetPredicate }
     *     {@link True }
     *     {@link False }
     *     
     */
    public void setPredicate(Predicate value) {
        this.predicate = value;
    }

    /**
     * Gets the value of the partition property.
     * 
     * @return
     *     possible object is
     *     {@link Partition }
     *     
     */
    public Partition getPartition() {
        return partition;
    }

    /**
     * Sets the value of the partition property.
     * 
     * @param value
     *     allowed object is
     *     {@link Partition }
     *     
     */
    public void setPartition(Partition value) {
        this.partition = value;
    }

    /**
     * Gets the value of the scoreDistributions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the scoreDistributions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getScoreDistributions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ScoreDistribution }
     * 
     * 
     */
    public List<ScoreDistribution> getScoreDistributions() {
        if (scoreDistributions == null) {
            scoreDistributions = new ArrayList<ScoreDistribution>();
        }
        return this.scoreDistributions;
    }

    /**
     * Gets the value of the nodes property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the nodes property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getNodes().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Node }
     * 
     * 
     */
    public List<Node> getNodes() {
        if (nodes == null) {
            nodes = new ArrayList<Node>();
        }
        return this.nodes;
    }

    /**
     * Gets the value of the embeddedModel property.
     * 
     * @return
     *     possible object is
     *     {@link Regression }
     *     {@link DecisionTree }
     *     
     */
    public PMMLObject getEmbeddedModel() {
        return embeddedModel;
    }

    /**
     * Sets the value of the embeddedModel property.
     * 
     * @param value
     *     allowed object is
     *     {@link Regression }
     *     {@link DecisionTree }
     *     
     */
    public void setEmbeddedModel(PMMLObject value) {
        this.embeddedModel = value;
    }

    /**
     * Gets the value of the id property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setId(String value) {
        this.id = value;
    }

    /**
     * Gets the value of the score property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getScore() {
        return score;
    }

    /**
     * Sets the value of the score property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setScore(String value) {
        this.score = value;
    }

    /**
     * Gets the value of the recordCount property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getRecordCount() {
        return recordCount;
    }

    /**
     * Sets the value of the recordCount property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setRecordCount(Double value) {
        this.recordCount = value;
    }

    /**
     * Gets the value of the defaultChild property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDefaultChild() {
        return defaultChild;
    }

    /**
     * Sets the value of the defaultChild property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDefaultChild(String value) {
        this.defaultChild = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof Node)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final Node that = ((Node) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            Predicate lhsPredicate;
            lhsPredicate = this.getPredicate();
            Predicate rhsPredicate;
            rhsPredicate = that.getPredicate();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "predicate", lhsPredicate), LocatorUtils.property(thatLocator, "predicate", rhsPredicate), lhsPredicate, rhsPredicate)) {
                return false;
            }
        }
        {
            Partition lhsPartition;
            lhsPartition = this.getPartition();
            Partition rhsPartition;
            rhsPartition = that.getPartition();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "partition", lhsPartition), LocatorUtils.property(thatLocator, "partition", rhsPartition), lhsPartition, rhsPartition)) {
                return false;
            }
        }
        {
            List<ScoreDistribution> lhsScoreDistributions;
            lhsScoreDistributions = (((this.scoreDistributions!= null)&&(!this.scoreDistributions.isEmpty()))?this.getScoreDistributions():null);
            List<ScoreDistribution> rhsScoreDistributions;
            rhsScoreDistributions = (((that.scoreDistributions!= null)&&(!that.scoreDistributions.isEmpty()))?that.getScoreDistributions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "scoreDistributions", lhsScoreDistributions), LocatorUtils.property(thatLocator, "scoreDistributions", rhsScoreDistributions), lhsScoreDistributions, rhsScoreDistributions)) {
                return false;
            }
        }
        {
            List<Node> lhsNodes;
            lhsNodes = (((this.nodes!= null)&&(!this.nodes.isEmpty()))?this.getNodes():null);
            List<Node> rhsNodes;
            rhsNodes = (((that.nodes!= null)&&(!that.nodes.isEmpty()))?that.getNodes():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nodes", lhsNodes), LocatorUtils.property(thatLocator, "nodes", rhsNodes), lhsNodes, rhsNodes)) {
                return false;
            }
        }
        {
            PMMLObject lhsEmbeddedModel;
            lhsEmbeddedModel = this.getEmbeddedModel();
            PMMLObject rhsEmbeddedModel;
            rhsEmbeddedModel = that.getEmbeddedModel();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "embeddedModel", lhsEmbeddedModel), LocatorUtils.property(thatLocator, "embeddedModel", rhsEmbeddedModel), lhsEmbeddedModel, rhsEmbeddedModel)) {
                return false;
            }
        }
        {
            String lhsId;
            lhsId = this.getId();
            String rhsId;
            rhsId = that.getId();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "id", lhsId), LocatorUtils.property(thatLocator, "id", rhsId), lhsId, rhsId)) {
                return false;
            }
        }
        {
            String lhsScore;
            lhsScore = this.getScore();
            String rhsScore;
            rhsScore = that.getScore();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "score", lhsScore), LocatorUtils.property(thatLocator, "score", rhsScore), lhsScore, rhsScore)) {
                return false;
            }
        }
        {
            Double lhsRecordCount;
            lhsRecordCount = this.getRecordCount();
            Double rhsRecordCount;
            rhsRecordCount = that.getRecordCount();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "recordCount", lhsRecordCount), LocatorUtils.property(thatLocator, "recordCount", rhsRecordCount), lhsRecordCount, rhsRecordCount)) {
                return false;
            }
        }
        {
            String lhsDefaultChild;
            lhsDefaultChild = this.getDefaultChild();
            String rhsDefaultChild;
            rhsDefaultChild = that.getDefaultChild();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "defaultChild", lhsDefaultChild), LocatorUtils.property(thatLocator, "defaultChild", rhsDefaultChild), lhsDefaultChild, rhsDefaultChild)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            Predicate thePredicate;
            thePredicate = this.getPredicate();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "predicate", thePredicate), currentHashCode, thePredicate);
        }
        {
            Partition thePartition;
            thePartition = this.getPartition();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "partition", thePartition), currentHashCode, thePartition);
        }
        {
            List<ScoreDistribution> theScoreDistributions;
            theScoreDistributions = (((this.scoreDistributions!= null)&&(!this.scoreDistributions.isEmpty()))?this.getScoreDistributions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "scoreDistributions", theScoreDistributions), currentHashCode, theScoreDistributions);
        }
        {
            List<Node> theNodes;
            theNodes = (((this.nodes!= null)&&(!this.nodes.isEmpty()))?this.getNodes():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "nodes", theNodes), currentHashCode, theNodes);
        }
        {
            PMMLObject theEmbeddedModel;
            theEmbeddedModel = this.getEmbeddedModel();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "embeddedModel", theEmbeddedModel), currentHashCode, theEmbeddedModel);
        }
        {
            String theId;
            theId = this.getId();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "id", theId), currentHashCode, theId);
        }
        {
            String theScore;
            theScore = this.getScore();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "score", theScore), currentHashCode, theScore);
        }
        {
            Double theRecordCount;
            theRecordCount = this.getRecordCount();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "recordCount", theRecordCount), currentHashCode, theRecordCount);
        }
        {
            String theDefaultChild;
            theDefaultChild = this.getDefaultChild();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "defaultChild", theDefaultChild), currentHashCode, theDefaultChild);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            Predicate thePredicate;
            thePredicate = this.getPredicate();
            strategy.appendField(locator, this, "predicate", buffer, thePredicate);
        }
        {
            Partition thePartition;
            thePartition = this.getPartition();
            strategy.appendField(locator, this, "partition", buffer, thePartition);
        }
        {
            List<ScoreDistribution> theScoreDistributions;
            theScoreDistributions = (((this.scoreDistributions!= null)&&(!this.scoreDistributions.isEmpty()))?this.getScoreDistributions():null);
            strategy.appendField(locator, this, "scoreDistributions", buffer, theScoreDistributions);
        }
        {
            List<Node> theNodes;
            theNodes = (((this.nodes!= null)&&(!this.nodes.isEmpty()))?this.getNodes():null);
            strategy.appendField(locator, this, "nodes", buffer, theNodes);
        }
        {
            PMMLObject theEmbeddedModel;
            theEmbeddedModel = this.getEmbeddedModel();
            strategy.appendField(locator, this, "embeddedModel", buffer, theEmbeddedModel);
        }
        {
            String theId;
            theId = this.getId();
            strategy.appendField(locator, this, "id", buffer, theId);
        }
        {
            String theScore;
            theScore = this.getScore();
            strategy.appendField(locator, this, "score", buffer, theScore);
        }
        {
            Double theRecordCount;
            theRecordCount = this.getRecordCount();
            strategy.appendField(locator, this, "recordCount", buffer, theRecordCount);
        }
        {
            String theDefaultChild;
            theDefaultChild = this.getDefaultChild();
            strategy.appendField(locator, this, "defaultChild", buffer, theDefaultChild);
        }
        return buffer;
    }

}
