
package org.dmg.pmml;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="quantileLimit" use="required" type="{http://www.dmg.org/PMML-4_1}PERCENTAGE-NUMBER" />
 *       &lt;attribute name="quantileValue" use="required" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions"
})
@XmlRootElement(name = "Quantile")
public class Quantile
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlAttribute(name = "quantileLimit", required = true)
    protected BigDecimal quantileLimit;
    @XmlAttribute(name = "quantileValue", required = true)
    protected double quantileValue;

    @Deprecated
    public Quantile() {
        super();
    }

    public Quantile(final BigDecimal quantileLimit, final double quantileValue) {
        super();
        this.quantileLimit = quantileLimit;
        this.quantileValue = quantileValue;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the quantileLimit property.
     * 
     * @return
     *     possible object is
     *     {@link BigDecimal }
     *     
     */
    public BigDecimal getQuantileLimit() {
        return quantileLimit;
    }

    /**
     * Sets the value of the quantileLimit property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigDecimal }
     *     
     */
    public void setQuantileLimit(BigDecimal value) {
        this.quantileLimit = value;
    }

    /**
     * Gets the value of the quantileValue property.
     * 
     */
    public double getQuantileValue() {
        return quantileValue;
    }

    /**
     * Sets the value of the quantileValue property.
     * 
     */
    public void setQuantileValue(double value) {
        this.quantileValue = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof Quantile)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final Quantile that = ((Quantile) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            BigDecimal lhsQuantileLimit;
            lhsQuantileLimit = this.getQuantileLimit();
            BigDecimal rhsQuantileLimit;
            rhsQuantileLimit = that.getQuantileLimit();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "quantileLimit", lhsQuantileLimit), LocatorUtils.property(thatLocator, "quantileLimit", rhsQuantileLimit), lhsQuantileLimit, rhsQuantileLimit)) {
                return false;
            }
        }
        {
            double lhsQuantileValue;
            lhsQuantileValue = (true?this.getQuantileValue(): 0.0D);
            double rhsQuantileValue;
            rhsQuantileValue = (true?that.getQuantileValue(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "quantileValue", lhsQuantileValue), LocatorUtils.property(thatLocator, "quantileValue", rhsQuantileValue), lhsQuantileValue, rhsQuantileValue)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            BigDecimal theQuantileLimit;
            theQuantileLimit = this.getQuantileLimit();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "quantileLimit", theQuantileLimit), currentHashCode, theQuantileLimit);
        }
        {
            double theQuantileValue;
            theQuantileValue = (true?this.getQuantileValue(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "quantileValue", theQuantileValue), currentHashCode, theQuantileValue);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            BigDecimal theQuantileLimit;
            theQuantileLimit = this.getQuantileLimit();
            strategy.appendField(locator, this, "quantileLimit", buffer, theQuantileLimit);
        }
        {
            double theQuantileValue;
            theQuantileValue = (true?this.getQuantileValue(): 0.0D);
            strategy.appendField(locator, this, "quantileValue", buffer, theQuantileValue);
        }
        return buffer;
    }

}
