
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}XCoordinates"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}YCoordinates"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}BoundaryValues" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "xCoordinates",
    "yCoordinates",
    "boundaryValues"
})
@XmlRootElement(name = "ROCGraph")
@Schema(min = Version.PMML_4_0)
public class ROCGraph
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "XCoordinates", required = true)
    protected XCoordinates xCoordinates;
    @XmlElement(name = "YCoordinates", required = true)
    protected YCoordinates yCoordinates;
    @XmlElement(name = "BoundaryValues")
    protected BoundaryValues boundaryValues;

    @Deprecated
    public ROCGraph() {
        super();
    }

    public ROCGraph(final XCoordinates xCoordinates, final YCoordinates yCoordinates) {
        super();
        this.xCoordinates = xCoordinates;
        this.yCoordinates = yCoordinates;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the xCoordinates property.
     * 
     * @return
     *     possible object is
     *     {@link XCoordinates }
     *     
     */
    public XCoordinates getXCoordinates() {
        return xCoordinates;
    }

    /**
     * Sets the value of the xCoordinates property.
     * 
     * @param value
     *     allowed object is
     *     {@link XCoordinates }
     *     
     */
    public void setXCoordinates(XCoordinates value) {
        this.xCoordinates = value;
    }

    /**
     * Gets the value of the yCoordinates property.
     * 
     * @return
     *     possible object is
     *     {@link YCoordinates }
     *     
     */
    public YCoordinates getYCoordinates() {
        return yCoordinates;
    }

    /**
     * Sets the value of the yCoordinates property.
     * 
     * @param value
     *     allowed object is
     *     {@link YCoordinates }
     *     
     */
    public void setYCoordinates(YCoordinates value) {
        this.yCoordinates = value;
    }

    /**
     * Gets the value of the boundaryValues property.
     * 
     * @return
     *     possible object is
     *     {@link BoundaryValues }
     *     
     */
    public BoundaryValues getBoundaryValues() {
        return boundaryValues;
    }

    /**
     * Sets the value of the boundaryValues property.
     * 
     * @param value
     *     allowed object is
     *     {@link BoundaryValues }
     *     
     */
    public void setBoundaryValues(BoundaryValues value) {
        this.boundaryValues = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof ROCGraph)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final ROCGraph that = ((ROCGraph) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            XCoordinates lhsXCoordinates;
            lhsXCoordinates = this.getXCoordinates();
            XCoordinates rhsXCoordinates;
            rhsXCoordinates = that.getXCoordinates();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "xCoordinates", lhsXCoordinates), LocatorUtils.property(thatLocator, "xCoordinates", rhsXCoordinates), lhsXCoordinates, rhsXCoordinates)) {
                return false;
            }
        }
        {
            YCoordinates lhsYCoordinates;
            lhsYCoordinates = this.getYCoordinates();
            YCoordinates rhsYCoordinates;
            rhsYCoordinates = that.getYCoordinates();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "yCoordinates", lhsYCoordinates), LocatorUtils.property(thatLocator, "yCoordinates", rhsYCoordinates), lhsYCoordinates, rhsYCoordinates)) {
                return false;
            }
        }
        {
            BoundaryValues lhsBoundaryValues;
            lhsBoundaryValues = this.getBoundaryValues();
            BoundaryValues rhsBoundaryValues;
            rhsBoundaryValues = that.getBoundaryValues();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "boundaryValues", lhsBoundaryValues), LocatorUtils.property(thatLocator, "boundaryValues", rhsBoundaryValues), lhsBoundaryValues, rhsBoundaryValues)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            XCoordinates theXCoordinates;
            theXCoordinates = this.getXCoordinates();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "xCoordinates", theXCoordinates), currentHashCode, theXCoordinates);
        }
        {
            YCoordinates theYCoordinates;
            theYCoordinates = this.getYCoordinates();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "yCoordinates", theYCoordinates), currentHashCode, theYCoordinates);
        }
        {
            BoundaryValues theBoundaryValues;
            theBoundaryValues = this.getBoundaryValues();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "boundaryValues", theBoundaryValues), currentHashCode, theBoundaryValues);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            XCoordinates theXCoordinates;
            theXCoordinates = this.getXCoordinates();
            strategy.appendField(locator, this, "xCoordinates", buffer, theXCoordinates);
        }
        {
            YCoordinates theYCoordinates;
            theYCoordinates = this.getYCoordinates();
            strategy.appendField(locator, this, "yCoordinates", buffer, theYCoordinates);
        }
        {
            BoundaryValues theBoundaryValues;
            theBoundaryValues = this.getBoundaryValues();
            strategy.appendField(locator, this, "boundaryValues", buffer, theBoundaryValues);
        }
        return buffer;
    }

}
