
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}NumericPredictor" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}CategoricalPredictor" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}PredictorTerm" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="intercept" use="required" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="targetCategory" type="{http://www.w3.org/2001/XMLSchema}string" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "numericPredictors",
    "categoricalPredictors",
    "predictorTerms"
})
@XmlRootElement(name = "RegressionTable")
public class RegressionTable
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "NumericPredictor")
    protected List<NumericPredictor> numericPredictors;
    @XmlElement(name = "CategoricalPredictor")
    protected List<CategoricalPredictor> categoricalPredictors;
    @XmlElement(name = "PredictorTerm")
    protected List<PredictorTerm> predictorTerms;
    @XmlAttribute(name = "intercept", required = true)
    protected double intercept;
    @XmlAttribute(name = "targetCategory")
    protected String targetCategory;

    @Deprecated
    public RegressionTable() {
        super();
    }

    public RegressionTable(final double intercept) {
        super();
        this.intercept = intercept;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the numericPredictors property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the numericPredictors property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getNumericPredictors().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link NumericPredictor }
     * 
     * 
     */
    public List<NumericPredictor> getNumericPredictors() {
        if (numericPredictors == null) {
            numericPredictors = new ArrayList<NumericPredictor>();
        }
        return this.numericPredictors;
    }

    /**
     * Gets the value of the categoricalPredictors property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the categoricalPredictors property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getCategoricalPredictors().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link CategoricalPredictor }
     * 
     * 
     */
    public List<CategoricalPredictor> getCategoricalPredictors() {
        if (categoricalPredictors == null) {
            categoricalPredictors = new ArrayList<CategoricalPredictor>();
        }
        return this.categoricalPredictors;
    }

    /**
     * Gets the value of the predictorTerms property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the predictorTerms property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getPredictorTerms().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link PredictorTerm }
     * 
     * 
     */
    public List<PredictorTerm> getPredictorTerms() {
        if (predictorTerms == null) {
            predictorTerms = new ArrayList<PredictorTerm>();
        }
        return this.predictorTerms;
    }

    /**
     * Gets the value of the intercept property.
     * 
     */
    public double getIntercept() {
        return intercept;
    }

    /**
     * Sets the value of the intercept property.
     * 
     */
    public void setIntercept(double value) {
        this.intercept = value;
    }

    /**
     * Gets the value of the targetCategory property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTargetCategory() {
        return targetCategory;
    }

    /**
     * Sets the value of the targetCategory property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTargetCategory(String value) {
        this.targetCategory = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof RegressionTable)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final RegressionTable that = ((RegressionTable) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            List<NumericPredictor> lhsNumericPredictors;
            lhsNumericPredictors = (((this.numericPredictors!= null)&&(!this.numericPredictors.isEmpty()))?this.getNumericPredictors():null);
            List<NumericPredictor> rhsNumericPredictors;
            rhsNumericPredictors = (((that.numericPredictors!= null)&&(!that.numericPredictors.isEmpty()))?that.getNumericPredictors():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "numericPredictors", lhsNumericPredictors), LocatorUtils.property(thatLocator, "numericPredictors", rhsNumericPredictors), lhsNumericPredictors, rhsNumericPredictors)) {
                return false;
            }
        }
        {
            List<CategoricalPredictor> lhsCategoricalPredictors;
            lhsCategoricalPredictors = (((this.categoricalPredictors!= null)&&(!this.categoricalPredictors.isEmpty()))?this.getCategoricalPredictors():null);
            List<CategoricalPredictor> rhsCategoricalPredictors;
            rhsCategoricalPredictors = (((that.categoricalPredictors!= null)&&(!that.categoricalPredictors.isEmpty()))?that.getCategoricalPredictors():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "categoricalPredictors", lhsCategoricalPredictors), LocatorUtils.property(thatLocator, "categoricalPredictors", rhsCategoricalPredictors), lhsCategoricalPredictors, rhsCategoricalPredictors)) {
                return false;
            }
        }
        {
            List<PredictorTerm> lhsPredictorTerms;
            lhsPredictorTerms = (((this.predictorTerms!= null)&&(!this.predictorTerms.isEmpty()))?this.getPredictorTerms():null);
            List<PredictorTerm> rhsPredictorTerms;
            rhsPredictorTerms = (((that.predictorTerms!= null)&&(!that.predictorTerms.isEmpty()))?that.getPredictorTerms():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "predictorTerms", lhsPredictorTerms), LocatorUtils.property(thatLocator, "predictorTerms", rhsPredictorTerms), lhsPredictorTerms, rhsPredictorTerms)) {
                return false;
            }
        }
        {
            double lhsIntercept;
            lhsIntercept = (true?this.getIntercept(): 0.0D);
            double rhsIntercept;
            rhsIntercept = (true?that.getIntercept(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "intercept", lhsIntercept), LocatorUtils.property(thatLocator, "intercept", rhsIntercept), lhsIntercept, rhsIntercept)) {
                return false;
            }
        }
        {
            String lhsTargetCategory;
            lhsTargetCategory = this.getTargetCategory();
            String rhsTargetCategory;
            rhsTargetCategory = that.getTargetCategory();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "targetCategory", lhsTargetCategory), LocatorUtils.property(thatLocator, "targetCategory", rhsTargetCategory), lhsTargetCategory, rhsTargetCategory)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            List<NumericPredictor> theNumericPredictors;
            theNumericPredictors = (((this.numericPredictors!= null)&&(!this.numericPredictors.isEmpty()))?this.getNumericPredictors():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "numericPredictors", theNumericPredictors), currentHashCode, theNumericPredictors);
        }
        {
            List<CategoricalPredictor> theCategoricalPredictors;
            theCategoricalPredictors = (((this.categoricalPredictors!= null)&&(!this.categoricalPredictors.isEmpty()))?this.getCategoricalPredictors():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "categoricalPredictors", theCategoricalPredictors), currentHashCode, theCategoricalPredictors);
        }
        {
            List<PredictorTerm> thePredictorTerms;
            thePredictorTerms = (((this.predictorTerms!= null)&&(!this.predictorTerms.isEmpty()))?this.getPredictorTerms():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "predictorTerms", thePredictorTerms), currentHashCode, thePredictorTerms);
        }
        {
            double theIntercept;
            theIntercept = (true?this.getIntercept(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "intercept", theIntercept), currentHashCode, theIntercept);
        }
        {
            String theTargetCategory;
            theTargetCategory = this.getTargetCategory();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "targetCategory", theTargetCategory), currentHashCode, theTargetCategory);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            List<NumericPredictor> theNumericPredictors;
            theNumericPredictors = (((this.numericPredictors!= null)&&(!this.numericPredictors.isEmpty()))?this.getNumericPredictors():null);
            strategy.appendField(locator, this, "numericPredictors", buffer, theNumericPredictors);
        }
        {
            List<CategoricalPredictor> theCategoricalPredictors;
            theCategoricalPredictors = (((this.categoricalPredictors!= null)&&(!this.categoricalPredictors.isEmpty()))?this.getCategoricalPredictors():null);
            strategy.appendField(locator, this, "categoricalPredictors", buffer, theCategoricalPredictors);
        }
        {
            List<PredictorTerm> thePredictorTerms;
            thePredictorTerms = (((this.predictorTerms!= null)&&(!this.predictorTerms.isEmpty()))?this.getPredictorTerms():null);
            strategy.appendField(locator, this, "predictorTerms", buffer, thePredictorTerms);
        }
        {
            double theIntercept;
            theIntercept = (true?this.getIntercept(): 0.0D);
            strategy.appendField(locator, this, "intercept", buffer, theIntercept);
        }
        {
            String theTargetCategory;
            theTargetCategory = this.getTargetCategory();
            strategy.appendField(locator, this, "targetCategory", buffer, theTargetCategory);
        }
        return buffer;
    }

}
