
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElements;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}RuleSelectionMethod" maxOccurs="unbounded"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}ScoreDistribution" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;group ref="{http://www.dmg.org/PMML-4_1}Rule" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="recordCount" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="nbCorrect" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="defaultScore" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="defaultConfidence" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "ruleSelectionMethods",
    "scoreDistributions",
    "rules"
})
@XmlRootElement(name = "RuleSet")
public class RuleSet
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "RuleSelectionMethod", required = true)
    protected List<RuleSelectionMethod> ruleSelectionMethods;
    @XmlElement(name = "ScoreDistribution")
    protected List<ScoreDistribution> scoreDistributions;
    @XmlElements({
        @XmlElement(name = "SimpleRule", type = SimpleRule.class),
        @XmlElement(name = "CompoundRule", type = CompoundRule.class)
    })
    protected List<Rule> rules;
    @XmlAttribute(name = "recordCount")
    protected Double recordCount;
    @XmlAttribute(name = "nbCorrect")
    protected Double nbCorrect;
    @XmlAttribute(name = "defaultScore")
    protected String defaultScore;
    @XmlAttribute(name = "defaultConfidence")
    protected Double defaultConfidence;

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the ruleSelectionMethods property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the ruleSelectionMethods property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getRuleSelectionMethods().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link RuleSelectionMethod }
     * 
     * 
     */
    public List<RuleSelectionMethod> getRuleSelectionMethods() {
        if (ruleSelectionMethods == null) {
            ruleSelectionMethods = new ArrayList<RuleSelectionMethod>();
        }
        return this.ruleSelectionMethods;
    }

    /**
     * Gets the value of the scoreDistributions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the scoreDistributions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getScoreDistributions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ScoreDistribution }
     * 
     * 
     */
    public List<ScoreDistribution> getScoreDistributions() {
        if (scoreDistributions == null) {
            scoreDistributions = new ArrayList<ScoreDistribution>();
        }
        return this.scoreDistributions;
    }

    /**
     * Gets the value of the rules property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the rules property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getRules().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link SimpleRule }
     * {@link CompoundRule }
     * 
     * 
     */
    public List<Rule> getRules() {
        if (rules == null) {
            rules = new ArrayList<Rule>();
        }
        return this.rules;
    }

    /**
     * Gets the value of the recordCount property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getRecordCount() {
        return recordCount;
    }

    /**
     * Sets the value of the recordCount property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setRecordCount(Double value) {
        this.recordCount = value;
    }

    /**
     * Gets the value of the nbCorrect property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getNbCorrect() {
        return nbCorrect;
    }

    /**
     * Sets the value of the nbCorrect property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setNbCorrect(Double value) {
        this.nbCorrect = value;
    }

    /**
     * Gets the value of the defaultScore property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDefaultScore() {
        return defaultScore;
    }

    /**
     * Sets the value of the defaultScore property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDefaultScore(String value) {
        this.defaultScore = value;
    }

    /**
     * Gets the value of the defaultConfidence property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getDefaultConfidence() {
        return defaultConfidence;
    }

    /**
     * Sets the value of the defaultConfidence property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setDefaultConfidence(Double value) {
        this.defaultConfidence = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof RuleSet)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final RuleSet that = ((RuleSet) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            List<RuleSelectionMethod> lhsRuleSelectionMethods;
            lhsRuleSelectionMethods = (((this.ruleSelectionMethods!= null)&&(!this.ruleSelectionMethods.isEmpty()))?this.getRuleSelectionMethods():null);
            List<RuleSelectionMethod> rhsRuleSelectionMethods;
            rhsRuleSelectionMethods = (((that.ruleSelectionMethods!= null)&&(!that.ruleSelectionMethods.isEmpty()))?that.getRuleSelectionMethods():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "ruleSelectionMethods", lhsRuleSelectionMethods), LocatorUtils.property(thatLocator, "ruleSelectionMethods", rhsRuleSelectionMethods), lhsRuleSelectionMethods, rhsRuleSelectionMethods)) {
                return false;
            }
        }
        {
            List<ScoreDistribution> lhsScoreDistributions;
            lhsScoreDistributions = (((this.scoreDistributions!= null)&&(!this.scoreDistributions.isEmpty()))?this.getScoreDistributions():null);
            List<ScoreDistribution> rhsScoreDistributions;
            rhsScoreDistributions = (((that.scoreDistributions!= null)&&(!that.scoreDistributions.isEmpty()))?that.getScoreDistributions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "scoreDistributions", lhsScoreDistributions), LocatorUtils.property(thatLocator, "scoreDistributions", rhsScoreDistributions), lhsScoreDistributions, rhsScoreDistributions)) {
                return false;
            }
        }
        {
            List<Rule> lhsRules;
            lhsRules = (((this.rules!= null)&&(!this.rules.isEmpty()))?this.getRules():null);
            List<Rule> rhsRules;
            rhsRules = (((that.rules!= null)&&(!that.rules.isEmpty()))?that.getRules():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "rules", lhsRules), LocatorUtils.property(thatLocator, "rules", rhsRules), lhsRules, rhsRules)) {
                return false;
            }
        }
        {
            Double lhsRecordCount;
            lhsRecordCount = this.getRecordCount();
            Double rhsRecordCount;
            rhsRecordCount = that.getRecordCount();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "recordCount", lhsRecordCount), LocatorUtils.property(thatLocator, "recordCount", rhsRecordCount), lhsRecordCount, rhsRecordCount)) {
                return false;
            }
        }
        {
            Double lhsNbCorrect;
            lhsNbCorrect = this.getNbCorrect();
            Double rhsNbCorrect;
            rhsNbCorrect = that.getNbCorrect();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nbCorrect", lhsNbCorrect), LocatorUtils.property(thatLocator, "nbCorrect", rhsNbCorrect), lhsNbCorrect, rhsNbCorrect)) {
                return false;
            }
        }
        {
            String lhsDefaultScore;
            lhsDefaultScore = this.getDefaultScore();
            String rhsDefaultScore;
            rhsDefaultScore = that.getDefaultScore();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "defaultScore", lhsDefaultScore), LocatorUtils.property(thatLocator, "defaultScore", rhsDefaultScore), lhsDefaultScore, rhsDefaultScore)) {
                return false;
            }
        }
        {
            Double lhsDefaultConfidence;
            lhsDefaultConfidence = this.getDefaultConfidence();
            Double rhsDefaultConfidence;
            rhsDefaultConfidence = that.getDefaultConfidence();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "defaultConfidence", lhsDefaultConfidence), LocatorUtils.property(thatLocator, "defaultConfidence", rhsDefaultConfidence), lhsDefaultConfidence, rhsDefaultConfidence)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            List<RuleSelectionMethod> theRuleSelectionMethods;
            theRuleSelectionMethods = (((this.ruleSelectionMethods!= null)&&(!this.ruleSelectionMethods.isEmpty()))?this.getRuleSelectionMethods():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "ruleSelectionMethods", theRuleSelectionMethods), currentHashCode, theRuleSelectionMethods);
        }
        {
            List<ScoreDistribution> theScoreDistributions;
            theScoreDistributions = (((this.scoreDistributions!= null)&&(!this.scoreDistributions.isEmpty()))?this.getScoreDistributions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "scoreDistributions", theScoreDistributions), currentHashCode, theScoreDistributions);
        }
        {
            List<Rule> theRules;
            theRules = (((this.rules!= null)&&(!this.rules.isEmpty()))?this.getRules():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "rules", theRules), currentHashCode, theRules);
        }
        {
            Double theRecordCount;
            theRecordCount = this.getRecordCount();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "recordCount", theRecordCount), currentHashCode, theRecordCount);
        }
        {
            Double theNbCorrect;
            theNbCorrect = this.getNbCorrect();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "nbCorrect", theNbCorrect), currentHashCode, theNbCorrect);
        }
        {
            String theDefaultScore;
            theDefaultScore = this.getDefaultScore();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "defaultScore", theDefaultScore), currentHashCode, theDefaultScore);
        }
        {
            Double theDefaultConfidence;
            theDefaultConfidence = this.getDefaultConfidence();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "defaultConfidence", theDefaultConfidence), currentHashCode, theDefaultConfidence);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            List<RuleSelectionMethod> theRuleSelectionMethods;
            theRuleSelectionMethods = (((this.ruleSelectionMethods!= null)&&(!this.ruleSelectionMethods.isEmpty()))?this.getRuleSelectionMethods():null);
            strategy.appendField(locator, this, "ruleSelectionMethods", buffer, theRuleSelectionMethods);
        }
        {
            List<ScoreDistribution> theScoreDistributions;
            theScoreDistributions = (((this.scoreDistributions!= null)&&(!this.scoreDistributions.isEmpty()))?this.getScoreDistributions():null);
            strategy.appendField(locator, this, "scoreDistributions", buffer, theScoreDistributions);
        }
        {
            List<Rule> theRules;
            theRules = (((this.rules!= null)&&(!this.rules.isEmpty()))?this.getRules():null);
            strategy.appendField(locator, this, "rules", buffer, theRules);
        }
        {
            Double theRecordCount;
            theRecordCount = this.getRecordCount();
            strategy.appendField(locator, this, "recordCount", buffer, theRecordCount);
        }
        {
            Double theNbCorrect;
            theNbCorrect = this.getNbCorrect();
            strategy.appendField(locator, this, "nbCorrect", buffer, theNbCorrect);
        }
        {
            String theDefaultScore;
            theDefaultScore = this.getDefaultScore();
            strategy.appendField(locator, this, "defaultScore", buffer, theDefaultScore);
        }
        {
            Double theDefaultConfidence;
            theDefaultConfidence = this.getDefaultConfidence();
            strategy.appendField(locator, this, "defaultConfidence", buffer, theDefaultConfidence);
        }
        return buffer;
    }

}
